// k5_pgina_plugin.cpp : Defines the initialization routines for the DLL.
//

/*
 * Copyright (c) 2007, University of Wisconsin-Madison
 *
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 *
 *      Tim Czerwonka                   Reseacher
 *      timc@cs.wisc.edu                Computer Sciences Department
 *      http://www.cs.wisc.edu/~timc    University of Wisconsin - Madison
 *      phone: 608-262-6610             1210 West Dayton Street
 *                                      Madison, WI 53706
 *
 */


// plugin framework is from the pGina-1.8.8 SamplePlugin.cpp
//
//
// $Id: k5_pgina_plugin.cpp,v 1.7 2008/04/07 19:12:31 timc Exp $
//
//
// $Log: k5_pgina_plugin.cpp,v $
// Revision 1.7  2008/04/07 19:12:31  timc
// don't be admin by default
//
// Revision 1.6  2007/12/17 21:17:48  timc
// *** empty log message ***
//
// Revision 1.5  2007/12/17 21:08:55  timc
// *** empty log message ***
//
// Revision 1.4  2007/12/17 20:53:37  timc
// added license
//
// Revision 1.3  2007/12/06 21:14:53  timc
// code cleanup, use registry value to set service
//
// Revision 1.2  2007/10/26 21:41:27  timc
// k5 login working, no tickets stashed yet
//
// Revision 1.1  2007/10/22 19:43:25  timc
// Initial revision
//
//
//


#include "stdafx.h"
#include "k5_pgina_plugin.h"
#include "ConfigDialog.h"
#include "uwutil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



SAMPLEPLUGIN_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo) {
	int iLifetime = 26 * UWG_LIFE_HOURS;
	bool retval = FALSE;



	debug_print("k5_pgina_plug/UserLogin - 1\n");
	//take the username and password and get a k5 ticket
	retval = GetK5Ticket(Username, Password, iLifetime, TRUE);

	if(retval) {
		debug_print("k5_pgina_plugin/UserLogin - 2 - GetK5Ticket - true\n");
		settingsInfo->isAdmin = false;
		settingsInfo->userDescription = _tcsdup(TEXT("KerberosV Plugin User"));
		settingsInfo->userFullName = _tcsdup(Username);
		settingsInfo->userGroups = _tcsdup(TEXT("Users"));
		settingsInfo->errorString = _tcsdup(TEXT(""));

		debug_print("k5_pgina_plugin/UserLogin - 3 - valid passwd for %S\n",Username);
		return true;
	}
		debug_print("k5_pgina_plugin/UserLogin - 2 - GetK5Ticket - false\n");
		settingsInfo->errorString = _tcsdup(TEXT("Password is incorrect"));
	return false;
}




SAMPLEPLUGIN_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword) {
	return true;
}

SAMPLEPLUGIN_API LPCTSTR AboutPlugin(void)
{
	return TEXT("KerberosV pGina plugin Copyright 2007 University of Wisconsin-Madison - T. Czerwonka, timc@cs.wisc.edu");
}

SAMPLEPLUGIN_API void ChangePluginSettings(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CConfigDialog *myDialog = new CConfigDialog();
	myDialog->DoModal();
}

SAMPLEPLUGIN_API void LoginHook(pGinaInfo *settingsInfo)
{
}

SAMPLEPLUGIN_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

SAMPLEPLUGIN_API BOOL IsRequired(void)
{
		return false;
}


/////////////////////////////////////////////////////////////////////////////
// Ck5_pgina_pluginApp

BEGIN_MESSAGE_MAP(Ck5_pgina_pluginApp, CWinApp)
	//{{AFX_MSG_MAP(Ck5_pgina_pluginApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	//ON_LBN_SELCHANGE(IDC_DEFAULT_REALM, &Ck5_pgina_pluginApp::OnLbnSelchangeDefaultRealm)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Ck5_pgina_pluginApp construction

Ck5_pgina_pluginApp::Ck5_pgina_pluginApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only Ck5_pgina_pluginApp object

Ck5_pgina_pluginApp theApp;

void Ck5_pgina_pluginApp::OnLbnSelchangeDefaultRealm()
{
	// TODO: Add your control notification handler code here
}
